#!/usr/bin/env ruby
=begin
Html Bookmark Compare v2.1.3
Ruby version

Copyright John Lakkas
Licence: GPLv3

http://bookmarkcompare.sourceforge.net/

=end

require 'gtk2'

$mainwindow = Gtk::Window.new("Bookmark Compare")
$mainwindow.signal_connect("destroy") do
	$mainwindow.destroy
	Gtk.main_quit
end
#mainwindow.border_width = 0
$mainwindow.set_window_position(Gtk::Window::POS_CENTER)
$mainwindow.set_size_request(550, 400)
vbox1 = Gtk::VBox.new(false, 0)
$mainwindow.add(vbox1)

filefilter = Gtk::FileFilter.new
filefilter.name = "Bookmarks"
filefilter.add_pattern("*.html")

$fileopenwindow = Gtk::Window.new("Open Bookmark")
$fileopenwindow.signal_connect("delete-event") do
	$fileopenwindow.visible=false
	true
end
$fileopenwindow.set_window_position(Gtk::Window::POS_CENTER)
$fileopenwindow.set_size_request(550, 400)
$fileopenwindow.border_width = 10
filevbox = Gtk::VBox.new(false, 0)
$fileopenwindow.add(filevbox)
$filechooser=Gtk::FileChooserWidget.new(Gtk::FileChooser::ACTION_OPEN)
$fileopen=Gtk::Button.new(Gtk::Stock::OPEN)
$fileopen.set_size_request(80, 25)
$filecancel=Gtk::Button.new(Gtk::Stock::CANCEL)
$filecancel.set_size_request(80, 25)
filevbox.pack_start($filechooser, true, true, 0)
buttonhbox = Gtk::HBox.new(false, 0)
filevbox.pack_start(buttonhbox, false, false, 5)
buttonhbox.pack_end($fileopen, false, false, 0)
buttonhbox.pack_end($filecancel, false, true, 10)
$fileopenwindow.visible=false
$filechooser.add_filter(filefilter)
$fileopen.signal_connect("clicked") do
	if $openpane==0
		$pathtxt0.text=$filechooser.filename
		$fileopenwindow.visible=false
		$loadingwindow.visible=true
		loaddata(0)
	else
		$pathtxt1.text=$filechooser.filename
		$fileopenwindow.visible=false
		$loadingwindow.visible=true
		loaddata(1)
	end
	#Gdk::Window.process_all_updates
end
$filechooser.signal_connect("file-activated") do
	if $openpane==0
		$pathtxt0.text=$filechooser.filename
		$fileopenwindow.visible=false
		$loadingwindow.visible=true
		loaddata(0)
	else
		$pathtxt1.text=$filechooser.filename
		$fileopenwindow.visible=false
		$loadingwindow.visible=true
		loaddata(1)
	end
	#Gdk::Window.process_all_updates
end
$filecancel.signal_connect("clicked") do
	$fileopenwindow.visible=false
end

$loadingwindow = Gtk::Window.new("Loading...")
$loadingwindow.signal_connect("delete-event") do
	$loadingwindow.visible=false
	true
end
$loadingwindow.set_window_position(Gtk::Window::POS_CENTER)
$loadingwindow.border_width = 10
loadvbox = Gtk::VBox.new(false, 0)
$loadingwindow.add(loadvbox)
$loadbar=Gtk::ProgressBar.new
loadvbox.pack_start($loadbar, false, false, 0)
#$loadbar.set_fraction(1)
$loadingwindow.visible=false

$aboutwindow = Gtk::Window.new("About")
$aboutwindow.signal_connect("delete-event") do
	$aboutwindow.visible=false
	true
end
$aboutwindow.set_window_position(Gtk::Window::POS_CENTER)
$aboutwindow.border_width = 10
aboutvbox = Gtk::VBox.new(false, 0)
$aboutwindow.add(aboutvbox)
$aboutlbl=Gtk::Label.new
aboutvbox.pack_start($aboutlbl, false, false, 0)
$aboutlbl.label="Bookmark compare\nv2.1.3 ruby version\nCopyright John Lakkas\nLicence: GPL v3\n\nhttp://bookmarkcompare.sourceforge.net/"
$aboutwindow.visible=false

menubar=Gtk::MenuBar.new
vbox1.pack_start(menubar, false, true, 0)

#$menu = Gtk::Menu.new

filemm = Gtk::MenuItem.new("File")
editmm = Gtk::MenuItem.new("Edit")
toolsmm = Gtk::MenuItem.new("Tools")
helpmm = Gtk::MenuItem.new("Help")
menubar.append(filemm)
menubar.append(editmm)
menubar.append(toolsmm)
menubar.append(helpmm)

filemm_menu = Gtk::Menu.new
editmm_menu = Gtk::Menu.new
toolsmm_menu = Gtk::Menu.new
helpmm_menu = Gtk::Menu.new
filemm.set_submenu filemm_menu
editmm.set_submenu editmm_menu
toolsmm.set_submenu toolsmm_menu
helpmm.set_submenu helpmm_menu

# FILE submenus
openlpanem = Gtk::MenuItem.new("Open in left pane")
filemm_menu.append(openlpanem)
openlpanem.signal_connect('activate') do
	$fileopenwindow.visible=true
	$openpane=0
end
openrpanem = Gtk::MenuItem.new("Open in right pane")
filemm_menu.append(openrpanem)
openrpanem.signal_connect('activate') do
	$fileopenwindow.visible=true
	$openpane=1
end
filemmsep1 = Gtk::SeparatorMenuItem.new()
filemm_menu.append(filemmsep1)
clearresultsm = Gtk::MenuItem.new("Clear search results")
filemm_menu.append(clearresultsm)
clearresultsm.signal_connect('activate') do
	for j in 1..$filelines[0]
		$itterator0[j][3]=0
		$itterator0[j][5]='white'
		$itterator0[j][6]='black'
	end
	for j in 1..$filelines[1]
		$itterator1[j][3]=0
		$itterator1[j][5]='white'
		$itterator1[j][6]='black'
	end
	if $filelines[0] > 0
		$statusbar[0].push(1, "Loaded: #{$filelines[0]} folders and bookmarks")
	else
		$statusbar[0].push(1, "")
	end
	if $filelines[1] > 0
		$statusbar[1].push(1, "Loaded: #{$filelines[1]} folders and bookmarks")
	else
		$statusbar[1].push(1, "")
	end
end
filemmsep2 = Gtk::SeparatorMenuItem.new()
filemm_menu.append(filemmsep2)
closelpanem = Gtk::MenuItem.new("Close left pane")
filemm_menu.append(closelpanem)
closelpanem.signal_connect('activate') do
	erasearray(0)
	$pathtxt0.text=""
	$treestore0.clear()
	$filepaths[0]=""
	$fileitems[0] = 0
	$filefolders[0] = 0
	$filelines[0] = 0
	$statusbar[0].push(1, "")
end
closerpanem = Gtk::MenuItem.new("Close right pane")
filemm_menu.append(closerpanem)
closerpanem.signal_connect('activate') do
	erasearray(1)
	$pathtxt1.text=""
	$treestore1.clear()
	$filepaths[1]=""
	$fileitems[1] = 0
	$filefolders[1] = 0
	$filelines[1] = 0
	$statusbar[1].push(1, "")
end

# EDIT submenus
copynameaddrm = Gtk::MenuItem.new("Copy selected bookmark name and address")
editmm_menu.append(copynameaddrm)
copynameaddrm.signal_connect('activate') do
	clipboard = Gtk::Clipboard.get(Gdk::Selection::CLIPBOARD)
	if $htmlview0.has_focus? and $htmlview0.selection.selected != nil
		clipboard.set_text("#{$htmlview0.selection.selected[1]} [#{$htmlview0.selection.selected[4]}]")
		#clipboard.set_text("Left Pane!")
	end
	if $htmlview1.has_focus? and $htmlview1.selection.selected != nil
		clipboard.set_text("#{$htmlview1.selection.selected[1]} [#{$htmlview1.selection.selected[4]}]")
		#clipboard.set_text("Right Pane!")
	end
	clipboard.store
end
copynamem = Gtk::MenuItem.new("Copy selected bookmark name")
editmm_menu.append(copynamem)
copynamem.signal_connect('activate') do
	clipboard = Gtk::Clipboard.get(Gdk::Selection::CLIPBOARD)
	if $htmlview0.has_focus? and $htmlview0.selection.selected != nil
		clipboard.set_text($htmlview0.selection.selected[1])
		#clipboard.set_text("Left Pane!")
	end
	if $htmlview1.has_focus? and $htmlview1.selection.selected != nil
		clipboard.set_text($htmlview1.selection.selected[1])
		#clipboard.set_text("Right Pane!")
	end
	clipboard.store
end
copyaddrm = Gtk::MenuItem.new("Copy selected bookmark address")
editmm_menu.append(copyaddrm)
copyaddrm.signal_connect('activate') do
	clipboard = Gtk::Clipboard.get(Gdk::Selection::CLIPBOARD)
	if $htmlview0.has_focus? and $htmlview0.selection.selected != nil
		clipboard.set_text($htmlview0.selection.selected[4])
		#clipboard.set_text("Left Pane!")
	end
	if $htmlview1.has_focus? and $htmlview1.selection.selected != nil
		clipboard.set_text($htmlview1.selection.selected[4])
		#clipboard.set_text("Right Pane!")
	end
	clipboard.store
end
editmmsep1 = Gtk::SeparatorMenuItem.new()
editmm_menu.append(editmmsep1)
copynamesm = Gtk::MenuItem.new("Copy folder's bookmark names")
editmm_menu.append(copynamesm)
copynamesm.signal_connect('activate') do
	clipboard = Gtk::Clipboard.get(Gdk::Selection::CLIPBOARD)
	if $htmlview0.has_focus? and $htmlview0.selection.selected != nil
		nameslist=""
		if $folder0[$htmlview0.selection.selected[2]]==false
			copyfolder=$upitem0[$htmlview0.selection.selected[2]]
		else
			copyfolder=$htmlview0.selection.selected[2]
		end
		for j in 1..$filelines[0]
			if copyfolder==$upitem0[j]
				nameslist += "#{$itemtxt0[j]} \n"
			end
		end
		clipboard.set_text(nameslist)
		#clipboard.set_text("Left Pane!")
	end
	if $htmlview1.has_focus? and $htmlview1.selection.selected != nil
		nameslist=""
		if $folder1[$htmlview1.selection.selected[2]]==false
			copyfolder=$upitem1[$htmlview1.selection.selected[2]]
		else
			copyfolder=$htmlview1.selection.selected[2]
		end
		for j in 1..$filelines[1]
			if copyfolder==$upitem1[j]
				nameslist += "#{$itemtxt1[j]} \n"
			end
		end
		clipboard.set_text(nameslist)
		#clipboard.set_text("Left Pane!")
	end
	clipboard.store
end
copynamesaddrm = Gtk::MenuItem.new("Copy folder's bookmark names and addresses")
editmm_menu.append(copynamesaddrm)
copynamesaddrm.signal_connect('activate') do
	clipboard = Gtk::Clipboard.get(Gdk::Selection::CLIPBOARD)
	if $htmlview0.has_focus? and $htmlview0.selection.selected != nil
		nameslist=""
		if $folder0[$htmlview0.selection.selected[2]]==false
			copyfolder=$upitem0[$htmlview0.selection.selected[2]]
		else
			copyfolder=$htmlview0.selection.selected[2]
		end
		for j in 1..$filelines[0]
			if copyfolder==$upitem0[j]
				nameslist += "#{$itemtxt0[j]} [#{$hrefatr0[j]}] \n"
			end
		end
		clipboard.set_text(nameslist)
		#clipboard.set_text("Left Pane!")
	end
	if $htmlview1.has_focus? and $htmlview1.selection.selected != nil
		nameslist=""
		if $folder1[$htmlview1.selection.selected[2]]==false
			copyfolder=$upitem1[$htmlview1.selection.selected[2]]
		else
			copyfolder=$htmlview1.selection.selected[2]
		end
		for j in 1..$filelines[1]
			if copyfolder==$upitem1[j]
				nameslist += "#{$itemtxt1[j]} [#{$hrefatr1[j]}] \n"
			end
		end
		clipboard.set_text(nameslist)
		#clipboard.set_text("Left Pane!")
	end
	clipboard.store
end
editmmsep2 = Gtk::SeparatorMenuItem.new()
editmm_menu.append(editmmsep2)
copynamesm = Gtk::MenuItem.new("Copy all bookmark names")
editmm_menu.append(copynamesm)
copynamesm.signal_connect('activate') do
	clipboard = Gtk::Clipboard.get(Gdk::Selection::CLIPBOARD)
	if $htmlview0.has_focus? and $filelines[0]>0
		nameslist=""
		for j in 1..$filelines[0]
			nameslist += "\t"*$hierarchy0[j] + "#{$itemtxt0[j]} \n"
		end
		clipboard.set_text(nameslist)
		#clipboard.set_text("Left Pane!")
	end
	if $htmlview1.has_focus? and $filelines[1]>0
		nameslist=""
		for j in 1..$filelines[1]
			nameslist += "\t"*$hierarchy1[j] + "#{$itemtxt1[j]} \n"
		end
		clipboard.set_text(nameslist)
		#clipboard.set_text("Left Pane!")
	end
	clipboard.store
end
copynamesaddrm = Gtk::MenuItem.new("Copy all names with addresses")
editmm_menu.append(copynamesaddrm)
copynamesaddrm.signal_connect('activate') do
	clipboard = Gtk::Clipboard.get(Gdk::Selection::CLIPBOARD)
	if $htmlview0.has_focus? and $filelines[0]>0
		nameslist=""
		for j in 1..$filelines[0]
			nameslist += "\t"*$hierarchy0[j] + "#{$itemtxt0[j]} [#{$hrefatr0[j]}] \n"
		end
		clipboard.set_text(nameslist)
		#clipboard.set_text("Left Pane!")
	end
	if $htmlview1.has_focus? and $filelines[1]>0
		nameslist=""
		for j in 1..$filelines[1]
			nameslist += "\t"*$hierarchy1[j] + "#{$itemtxt1[j]} [#{$hrefatr1[j]}] \n"
		end
		clipboard.set_text(nameslist)
		#clipboard.set_text("Left Pane!")
	end
	clipboard.store
end
copyfoldersm = Gtk::MenuItem.new("Copy all bookmark folders")
editmm_menu.append(copyfoldersm)
copyfoldersm.signal_connect('activate') do
	clipboard = Gtk::Clipboard.get(Gdk::Selection::CLIPBOARD)
	if $htmlview0.has_focus? and $filelines[0]>0
		nameslist=""
		for j in 1..$filelines[0]
			if $folder0[j]==true
				nameslist += "\t"*$hierarchy0[j] + "#{$itemtxt0[j]} \n"
			end
		end
		clipboard.set_text(nameslist)
		#clipboard.set_text("Left Pane!")
	end
	if $htmlview1.has_focus? and $filelines[1]>0
		nameslist=""
		for j in 1..$filelines[1]
			if $folder1[j]==true
				nameslist += "\t"*$hierarchy1[j] + "#{$itemtxt1[j]} \n"
			end
		end
		clipboard.set_text(nameslist)
		#clipboard.set_text("Left Pane!")
	end
	clipboard.store
end

# TOOLS submenus
comparefldm = Gtk::ImageMenuItem.new("Folder Compare")
comparefldm.set_image(Gtk::Image.new(Gtk::Stock::FIND, Gtk::IconSize::MENU))
comparefldm.always_show_image=true
toolsmm_menu.append(comparefldm)
comparefldm.signal_connect('activate') do
	foldcompm_click
end

# ABOUT submenus
aboutm = Gtk::ImageMenuItem.new("About")
aboutm.set_image(Gtk::Image.new(Gtk::Stock::ABOUT, Gtk::IconSize::MENU))
aboutm.always_show_image=true
helpmm_menu.append(aboutm)
aboutm.signal_connect('activate') do
	$aboutwindow.visible=true
end

hbox1 = Gtk::HBox.new(false, 0)
vbox1.pack_start(hbox1, false, true, 0)

$pathtxt0=Gtk::Entry.new()
sel_file0=Gtk::Button.new("...")
$pathtxt1=Gtk::Entry.new()
sel_file1=Gtk::Button.new("...")

hbox1.pack_start($pathtxt0, true, true, 0)
hbox1.pack_start(sel_file0, false, false, 0)
hbox1.pack_start($pathtxt1, true, true, 0)
hbox1.pack_start(sel_file1, false, false, 0)

#$pathtxt0.text="0"
#$pathtxt1.text="1"

hbox2 = Gtk::HBox.new(false, 0)
vbox1.pack_start(hbox2, true, true, 0)

scrolledwindow0 = Gtk::ScrolledWindow.new
scrolledwindow1 = Gtk::ScrolledWindow.new
hbox2.pack_start(scrolledwindow0, true, true, 0)
hbox2.pack_start(scrolledwindow1, true, true, 0)

$htmlview0 = Gtk::TreeView.new
#scrolledwindow0.add_with_viewport($htmlview0)
scrolledwindow0.add($htmlview0, nil)
scrolledwindow0.set_policy(Gtk::POLICY_AUTOMATIC, Gtk::POLICY_AUTOMATIC)
$htmlview1 = Gtk::TreeView.new
#scrolledwindow1.add_with_viewport($htmlview1)
scrolledwindow1.add($htmlview1, nil)
scrolledwindow1.set_policy(Gtk::POLICY_AUTOMATIC, Gtk::POLICY_AUTOMATIC)

$statusbar=[nil,nil]
$statusbar[0] = Gtk::Statusbar.new
$statusbar[1] = Gtk::Statusbar.new
vbox1.pack_start($statusbar[0], false, true, 0)
vbox1.pack_start($statusbar[1], false, true, 0)

#statusbar0.push(1, "0 blah blah")
#statusbar1.push(1, "1 blah blah")

# filechooserdialog =  Gtk::FileChooserDialog.new("Open Bookmark", nil, 
					 # Gtk::FileChooser::ACTION_OPEN,
					 # "gnome-vfs",
					 # [Gtk::Stock::OPEN, Gtk::Dialog::RESPONSE_ACCEPT],#Gtk::Stock::OPEN
					 # [Gtk::Stock::CANCEL, Gtk::Dialog::RESPONSE_CANCEL]
					 # )
# filechooserdialog.add_filter(filefilter)


#filechooserdialog.visible=false
#filechooserdialog.signal_connect("delete-event") do
	#puts "WARNING! delete signal!"
	#filechooserdialog.visible=false
	#true
#end


#filechooserdialog.signal_connect('open-file') do#Gtk::FileChooser::ACTION_OPEN
	#puts(filechooserdialog.filename)
	#filechooserdialog.visible=false
#end

sel_file0.signal_connect("clicked") do
	$fileopenwindow.visible=true
	$openpane=0
	# #filechooserdialog.show
	# if filechooserdialog.run == Gtk::Dialog::RESPONSE_ACCEPT
		# openfile=filechooserdialog.filename
		# $loadingwindow.show
	# end
	# if filechooserdialog.run == Gtk::Dialog::RESPONSE_CANCEL
		# openfile=''
		# filechooserdialog.visible=false
	# end
	# filechooserdialog.destroy
	#filechooserdialog.visible=false
	#puts $openfile
	#Gdk::Window.process_all_updates
	# if $openfile != nil and  $openfile != '' 
	  # $pathtxt0.text=$openfile
	  # ######$filepaths[0]=openfile
	  # loaddata(0)
	# end
end

sel_file1.signal_connect("clicked") do
	$fileopenwindow.visible=true
	$openpane=1
	# #filechooserdialog.show
	# #openfile='fail!'
	# #if filechooserdialog.get_response(Gtk::Dialog::RESPONSE_ACCEPT)
	# if filechooserdialog.run == Gtk::Dialog::RESPONSE_ACCEPT
		# openfile=filechooserdialog.filename
		# $loadingwindow.show
	# end
	# #if filechooserdialog.get_response(Gtk::Dialog::RESPONSE_CANCEL)
	# if filechooserdialog.run == Gtk::Dialog::RESPONSE_CANCEL
		# openfile=''
		# filechooserdialog.visible=false
	# end
	# puts $openfile
	# #Gdk::Window.process_all_updates
	# if $openfile != nil and  $openfile != '' 
		# $pathtxt1.text=$openfile
		# loaddata(1)
	# end
end

#columnicon0 = Gtk::TreeViewColumn.new("", Gtk::CellRendererPixbuf.new, {:pixbuf => 0})
#columnid0 = Gtk::TreeViewColumn.new("#", Gtk::CellRendererText.new, {:text=>2})
columnicon0 = Gtk::TreeViewColumn.new('Name')
iconrenderer0=Gtk::CellRendererPixbuf.new
textrenderer0=Gtk::CellRendererText.new
columnicon0.pack_start(iconrenderer0, false)
columnicon0.pack_start(textrenderer0, false)
columnicon0.set_attributes(iconrenderer0, :pixbuf => 0)
columnicon0.set_attributes(textrenderer0, {:text=>1, :background=>5, :foreground=>6})
columnicon0.set_resizable(true)
columnid0 = Gtk::TreeViewColumn.new('index', Gtk::CellRendererText.new, {:text=>2})
columnfound0 = Gtk::TreeViewColumn.new('found', Gtk::CellRendererText.new, {:text=>3})
columnhref0 = Gtk::TreeViewColumn.new('link', Gtk::CellRendererText.new, {:text=>4})
columnhref0.set_resizable(true)
#columnid0.set_resizable(false)
#cellwcolor0 = Gtk::CellRendererText.new()
#cellwcolor0.set_property('cell-background', 'red')
#cellwcolor0.set_property('foreground', 'white')
#columnname0 = Gtk::TreeViewColumn.new("Name", Gtk::CellRendererText.new, {:text=>1, :background=>4, :foreground=>5})
#columnname0.set_resizable(true)

#columnicon1 = Gtk::TreeViewColumn.new("", Gtk::CellRendererPixbuf.new, {:pixbuf => 0})
#columnid1 = Gtk::TreeViewColumn.new("#", Gtk::CellRendererText.new, {:text=>2})
columnicon1 = Gtk::TreeViewColumn.new('Name')
iconrenderer1=Gtk::CellRendererPixbuf.new
textrenderer1=Gtk::CellRendererText.new
columnicon1.pack_start(iconrenderer1, false)
columnicon1.pack_start(textrenderer1, false)
columnicon1.set_attributes(iconrenderer1, :pixbuf => 0)
columnicon1.set_attributes(textrenderer1, {:text=>1, :background=>5, :foreground=>6})
columnicon1.set_resizable(true)
columnid1 = Gtk::TreeViewColumn.new('index', Gtk::CellRendererText.new, {:text=>2})
columnfound1 = Gtk::TreeViewColumn.new('found', Gtk::CellRendererText.new, {:text=>3})
columnhref1 = Gtk::TreeViewColumn.new('link', Gtk::CellRendererText.new, {:text=>4})
columnhref1.set_resizable(true)
#columnid1.set_resizable(false)
#cellwcolor1 = Gtk::CellRendererText.new()
#cellwcolor1.set_property('cell-background', 'grey')
#columnname1 = Gtk::TreeViewColumn.new("Name", Gtk::CellRendererText.new, {:text=>1, :background=>3, :foreground=>4})
#columnname1.set_resizable(true)

$htmlview0.append_column(columnicon0)
$htmlview0.append_column(columnid0)
$htmlview0.append_column(columnfound0)
$htmlview0.append_column(columnhref0)
$htmlview1.append_column(columnicon1)
$htmlview1.append_column(columnid1)
$htmlview1.append_column(columnfound1)
$htmlview1.append_column(columnhref1)

$treestore0 = Gtk::TreeStore.new(Gdk::Pixbuf, String, Integer, Integer, String, String, String)
$treestore1 = Gtk::TreeStore.new(Gdk::Pixbuf, String, Integer, Integer, String, String, String)

#iter1 = $treestore0.append(nil)
#iter1[0]=$mainwindow.render_icon(Gtk::Stock::DIRECTORY, Gtk::IconSize::MENU, "icon2")
#iter1[1]="Cell 1"
#iter1[2]=1
#iter1[3]=0
#iter1[4]=''
#iter1[5]='white'
#iter1[6]='black'

#iter2 = $treestore0.append(iter1)
#iter2[0]=$mainwindow.render_icon(Gtk::Stock::FILE, Gtk::IconSize::MENU, "icon2")
#iter2[1]="Cell 1.1"
#iter2[2]=2
#iter1[3]=0
#iter2[4]="www."
#iter2[5]='white'
#iter2[6]='black'

#$htmlview0.set_model($treestore0)
#$htmlview1.set_model($treestore1)


#===========================>	  Data	 <===========================

#Prepare filepaths tuple
$filepaths=["",""]

#Prepare Total Bookmarks+Folders+Separators, Total Folders, Total Bookmarks count tuples
#Names describe html file data reproduction
$filelines=[0,0]
$filefolders=[0,0]
$fileitems=[0,0]

def erasearray(pane)
	#DATA HOLDERS initialization

	#Prepare Total Bookmarks+Folders+Separators, Total Folders, Total Bookmarks count tuples
	#Names describe html file data reproduction
	$filelines[pane]=0
	$filefolders[pane]=0
	$fileitems[pane]=0

	#Left pane Data: Name(str), Address/URL(str), Is-a-Folder(boolean),
	#Folder Containing it (int), Hierarchy(int)
	if pane==0
		$itemtxt0=[nil]
		$hrefatr0=[nil]
		$folder0=[nil]
		$upitem0=[nil]
		$hierarchy0=[nil]
		$itterator0=[nil]
	end

	#Right pane Data: Name(str), Address/URL(str), Is-a-Folder(boolean),
	#Folder Containing it (int), Hierarchy(int)
	if pane==1
		$itemtxt1=[nil]
		$hrefatr1=[nil]
		$folder1=[nil]
		$upitem1=[nil]
		$hierarchy1=[nil]
		$itterator1=[nil]
	end
end

#===========================>		FileI	  <===========================

def nonewln(instr)
	#nonewln(...)/n
	#Removes tailing newline character from the given string.
	if instr.include? "\n"
		instr=instr[0...instr.length-"\n".length]
	end
	return instr
end

def loaddata(pane)
	if pane==0
		fileopening=$pathtxt0.text
	else
		fileopening=$pathtxt1.text
	end
	
	$statusbar[pane].push(1, 'attempt oppening: ' + fileopening)
	
	if not File.exist?(fileopening)
		$statusbar[pane].push(1, 'Input file does not exist!')
		if pane==0
			$pathtxt0.set_text($filepaths[0])
		else
			$pathtxt1.set_text($filepaths[1])
		end
		return
	end
	
	f=File.open(fileopening, 'r')
	
	lstr=f.gets
	if not lstr.length - '<!DOCTYPE NETSCAPE-Bookmark-file-1>'.length <=2
		$statusbar[pane].push(1, 'Wrong file headers, please select a bookmark html file.')
		if pane==0
			$pathtxt0.set_text($filepaths[0])
		else
			$pathtxt1.set_text($filepaths[1])
		end
		f.close()
		puts lstr
		return
	end
	
	erasearray(pane)
	$loadbar.set_fraction(0)
	$statusbar[pane].push(1, 'Loading file')
	Gdk::Window.process_all_updates
	
	if pane==0
		$treestore0.clear()
		$filepaths[0]=$pathtxt0.text
	else
		$treestore1.clear()
		$filepaths[1]=$pathtxt1.text
	end
	
	$fileitems[pane] = 0
	$filefolders[pane] = 0
	$filelines[pane] = 0
	i = 0
	tmpcurhier = 0
	tmpitemup = 0
	
	while f.eof==false
		lstr=f.gets
		
		if lstr.downcase.include? '<a'
			i += 1
			if pane == 0
				$itemtxt0 << analyseanchor(lstr)[0]
				$hrefatr0 << analyseanchor(lstr)[1]
				$upitem0 << tmpitemup
				$hierarchy0 << tmpcurhier
				$folder0 << false
			else
				$itemtxt1 << analyseanchor(lstr)[0]
				$hrefatr1 << analyseanchor(lstr)[1]
				$upitem1 << tmpitemup
				$hierarchy1 << tmpcurhier
				$folder1 << false
			end
			#puts("h:#{$hierarchy0[i]} a:#{$filelines[pane]} up:#{$upitem0[i]} #{analyseanchor(lstr)[0][0..50]}")
			$fileitems[pane]+=1
			$filelines[pane]+=1
		end
		
		if lstr.downcase.include? '<hr'
			i += 1
			if pane == 0
				$itemtxt0 << '-'
				$hrefatr0 << ''
				$upitem0 << tmpitemup
				$hierarchy0 << tmpcurhier
				$folder0 << false
			else
				$itemtxt1 << '-'
				$hrefatr1 << ''
				$upitem1 << tmpitemup
				$hierarchy1 << tmpcurhier
				$folder1 << false
			end
			#puts("h:#{$hierarchy0[i]} h:#{$filelines[pane]} up:#{$upitem0[i]} ----")
			$filelines[pane]+=1
		end

		if lstr.downcase.include? '<h3'
			i += 1
			if pane == 0
				$itemtxt0 << h3_analyse(lstr)
				$hrefatr0 << ''
				$upitem0 << tmpitemup
				$hierarchy0 << tmpcurhier
				$folder0 << true
			else
				$itemtxt1 << h3_analyse(lstr)
				$hrefatr1 << ''
				$upitem1 << tmpitemup
				$hierarchy1 << tmpcurhier
				$folder1 << true
			end
			#puts('')
			#puts("h:#{$hierarchy0[i]} f:#{$filelines[pane]} up:#{$upitem0[i]} #{h3_analyse(lstr)[0..50]}")
			tmpcurhier += 1
			tmpitemup = i
			$filefolders[pane]+=1
			$filelines[pane]+=1
		end

		if lstr.downcase.include? '</dl>' and tmpcurhier > 1
			j = i
			if pane == 0
				while true
					j -= 1
					if j == 0
						break
					end
					if $hierarchy0[j] == tmpcurhier - 2
						tmpitemup = j
						break
					end
				end
			else
				while true
					j -= 1
					if j == 0
						break
					end
					if $hierarchy1[j] == tmpcurhier - 2
						tmpitemup = j
						break
					end
				end
			end
			tmpcurhier -= 1
		elsif lstr.downcase.include? '</dl>' and tmpcurhier == 1
			tmpitemup = 0
			tmpcurhier = 0
		elsif lstr.downcase.include? '</dl>' and tmpcurhier == 0
			tmpitemup = 0
		end
	end
	
	f.close()
	#$statusbar[pane].push(1, 'file load complete')
	previewdata(pane)
end

#===========================>	PreviewData	<===========================
def previewdata(pane)
	added=0
	hier=0

	$htmlview0.set_model(nil)
	$htmlview1.set_model(nil)
	
	if pane==0
		for i in 0..$filelines[0]
			$itterator0 << nil
		end
	else
		for i in 0..$filelines[1]
			$itterator1 << nil
		end
	end
	
	$statusbar[pane].push(1, 'Loading preview')
	Gdk::Window.process_all_updates
	
# iter1 = $treestore0.append(nil)
# iter1[0]=$mainwindow.render_icon(Gtk::Stock::DIRECTORY, Gtk::IconSize::MENU, "icon2")
# iter1[1]="Cell 1"
# iter1[2]=1
# iter1[3]=0
# iter1[4]=''
# iter1[5]='white'
# iter1[6]='black'
	
	if pane==0
		#for i in 0..$filelines[0]
			for j in 1..$filelines[0]
				if $hierarchy0[j]==0
					#itterator0[j]=treestore0.append(None, [j, itemtxt0[j], false])
					$itterator0[j] = $treestore0.append(nil)
					if $folder0[j]==false
						$itterator0[j][0]=$mainwindow.render_icon(Gtk::Stock::FILE, Gtk::IconSize::MENU, "icon2")
					else
						$itterator0[j][0]=$mainwindow.render_icon(Gtk::Stock::DIRECTORY, Gtk::IconSize::MENU, "icon2")
					end
					#$itterator0[j][0]=$mainwindow.render_icon(Gtk::Stock::FILE, Gtk::IconSize::MENU, "icon2")
					$itterator0[j][1]=$itemtxt0[j]
					$itterator0[j][2]=j
					$itterator0[j][3]=0
					$itterator0[j][4]=$hrefatr0[j]
					$itterator0[j][5]='white'
					$itterator0[j][6]='black'
				else
					#itterator0[j]=treestore0.append(itterator0[i], [j, itemtxt0[j], false])
					$itterator0[j] = $treestore0.append($itterator0[$upitem0[j]])
					if $folder0[j]==false
						$itterator0[j][0]=$mainwindow.render_icon(Gtk::Stock::FILE, Gtk::IconSize::MENU, "icon2")
					else
						$itterator0[j][0]=$mainwindow.render_icon(Gtk::Stock::DIRECTORY, Gtk::IconSize::MENU, "icon2")
					end
					#$itterator0[j][0]=$mainwindow.render_icon(Gtk::Stock::FILE, Gtk::IconSize::MENU, "icon2")
					$itterator0[j][1]=$itemtxt0[j]
					$itterator0[j][2]=j
					$itterator0[j][3]=0
					$itterator0[j][4]=$hrefatr0[j]
					$itterator0[j][5]='white'
					$itterator0[j][6]='black'
				end
				added+=1
				#$statusbar[0].push(1, "added #{added}/#{$filelines[0]}")
				$loadbar.set_fraction(added.to_f/$filelines[0].to_f)
				#Gdk::Window.process_all_updates#($loadingwindow)
				#$loadingwindow.queue_draw
				#event = Gtk::Gdk::Event.new(Gtk::Gdk::Event::EXPOSE)
				#emit("expose-event", event)
				if j.modulo(20)==0
					Gtk.main_iteration_do(false)
				end
			end
			hier+=1
		#end
	else
		#for i in 0..$filelines[1]
			for j in 1..$filelines[1]
				if $hierarchy1[j]==0
					#itterator1[j]=treestore0.append(None, [j, itemtxt0[j], false])
					$itterator1[j] = $treestore1.append(nil)
					if $folder1[j]==false
						$itterator1[j][0]=$mainwindow.render_icon(Gtk::Stock::FILE, Gtk::IconSize::MENU, "icon2")
					else
						$itterator1[j][0]=$mainwindow.render_icon(Gtk::Stock::DIRECTORY, Gtk::IconSize::MENU, "icon2")
					end
					$itterator1[j][1]=$itemtxt1[j]
					$itterator1[j][2]=j
					$itterator1[j][3]=0
					$itterator1[j][4]=$hrefatr1[j]
					$itterator1[j][5]='white'
					$itterator1[j][6]='black'
				else #elsif i==$upitem0[j]
					#itterator1[j]=treestore0.append(itterator0[i], [j, itemtxt0[j], false])
					$itterator1[j] = $treestore1.append($itterator1[$upitem1[j]])
					if $folder1[j]==false
						$itterator1[j][0]=$mainwindow.render_icon(Gtk::Stock::FILE, Gtk::IconSize::MENU, "icon2")
					else
						$itterator1[j][0]=$mainwindow.render_icon(Gtk::Stock::DIRECTORY, Gtk::IconSize::MENU, "icon2")
					end
					#$itterator1[j][0]=$mainwindow.render_icon(Gtk::Stock::FILE, Gtk::IconSize::MENU, "icon2")
					$itterator1[j][1]=$itemtxt1[j]
					$itterator1[j][2]=j
					$itterator1[j][3]=0
					$itterator1[j][4]=$hrefatr1[j]
					$itterator1[j][5]='white'
					$itterator1[j][6]='black'
				end
				added+=1
				#$statusbar[1].push(1, "added #{added}/#{$filelines[1]}")
				$loadbar.set_fraction(added.to_f/$filelines[1].to_f)
				#Gdk::Window.process_all_updates#($loadingwindow)
				#$loadingwindow.queue_draw
				#event = Gtk::Gdk::Event.new(Gtk::Gdk::Event::EXPOSE)
				#emit("expose-event", event)
				if j.modulo(20)==0
					Gtk.main_iteration_do(false)
				end
			end
			hier+=1
		#end
	end
	
	#puts('attempt to show data')
	
	$htmlview0.set_model($treestore0)
	$htmlview1.set_model($treestore1)
	
	$loadingwindow.visible=false
	$statusbar[pane].push(1, "Loaded: #{$filelines[pane]} folders and bookmarks")
end

#===========================>   HtmlTxtHandler  <===========================
#Note: usual chr(number) function in ruby is " ".setbyte(0,number)

def attrvaluefinder(tagattr, tagname)
	if tagattr.downcase.include?(' ' + tagname + '="')
		tagfrom = tagattr.downcase.index(' ' + tagname + '="') + (tagname + '"').length + 2
		tagto = tagattr[tagfrom...-1].downcase.index('"')
		tagvalue = tagattr[tagfrom...tagfrom+tagto]
		return tagvalue
	else
		return ''
	end
end
	
def analyseanchor(anchtxt)
	#puts(anchtxt)
	if anchtxt.downcase.include? '<a'
		anchprfrom = anchtxt.downcase.index('<a') + 2
		#if not anchprfrom == 0:
		anchprto = anchtxt.downcase.index('">') + 1
		anchinpr = anchtxt[anchprfrom..anchprto]
		href = attrvaluefinder(anchinpr, 'href')
		#icon = AttrValueFinder(anchinpr, 'icon')
		anchend = anchtxt[anchprto + 1..-1].downcase.index('</a>')
		avalue = anchtxt[anchprto+1..anchprto+anchend]
		return [avalue, href] #, Icon
	else
		return ['','']
	end
end

def h3_analyse(incltxt)
	if incltxt.downcase.include? '<h3'
		h3prfrom = incltxt.downcase.index('<h3') + 3
		#if not h3prfrom == 0:
		h3prto = incltxt.downcase.index('"' + '>') + 1
		h3inpr = incltxt[h3prfrom..h3prto]
		h3end = incltxt[h3prto + 1..-1].downcase.index('</h3>')
		h3value = incltxt[h3prto+1..h3prto+h3end]
		return h3value
	else
		return ''
	end
end

#===========================>	   ComMod	  <===========================

def foldcompm_click()
    #Dim i As Long, j As Long, k As Long, UsedBefore As Boolean, ResultsTbl() As Long, AllTheSame As Boolean
    
    #ReDim ResultsTbl(FileLines(1))
	
	$resultstbl=[0]
	for i in 0..$filelines[0]
		$resultstbl << 0
	end
    
    for i in 1..$filelines[0]
        if $folder0[i] == true
            for j in 1..$filelines[1]
                if $folder1[j] == true and $itemtxt0[i] == $itemtxt1[j]
                    usedbefore = false
                    k = 1
                    while not k >= $filelines[1]
                        if $resultstbl[k] == j
                            usedbefore = true
                        end
                        k = k + 1
                    end
                    if usedbefore == false
                        foldercontcom(i, j)
                        $resultstbl[i] = j
                        break
                    end
                end
            end
        end
    end
    foldercontcom(0, 0)
    foldercomp()
    
	differentbookmarks=0
	
    for i in 1..$filelines[0]
        if $resultstbl[i] > 0
            #HtmlView(0).Nodes.Item(i + 1).BackColor = RGB(155, 251, 153)
            #HtmlView(1).Nodes.Item(ResultsTbl(i) + 1).BackColor = RGB(155, 251, 153)
            #HtmlView(0).Nodes.Item(i + 1).Text = "[" & ResultsTbl(i) & "] " & HtmlView(0).Nodes.Item(i + 1).Text
            #HtmlView(1).Nodes.Item(ResultsTbl(i) + 1).Text = "[" & i & "] " & HtmlView(1).Nodes.Item(ResultsTbl(i) + 1).Text
			$itterator0[i][3]=$resultstbl[i]
			$itterator0[i][5]='light grey'
			$itterator0[i][6]='black'
			
			$itterator1[$resultstbl[i]][3]=i
			$itterator1[$resultstbl[i]][5]='light grey'
			$itterator1[$resultstbl[i]][6]='black'
        else
			if $itterator0[i][1] != "-"
				$itterator0[i][5]='red'
				$itterator0[i][6]='white'
				if $folder0[i]==false
					differentbookmarks += 1
				end
			end
		end
    end
    
    allthesame = true
    for i in 1..$filelines[0]
        if ($folder0[i] == true or $hierarchy0[i] = 0) and $itemtxt0[i] != "-"
            if $resultstbl[i] == 0
                allthesame = false
            end
        end
    end
    
    if allthesame == true
    	if $filelines[0]==$filelines[1]
    		$statusbar[0].push(1, "Left and right panes are identical.")
    	else
        	$statusbar[0].push(1, "Everything in the left pane has an equivalent item in the right pane.")
        end
		$statusbar[1].push(1, "Different bookmarks: #{differentbookmarks}")
    else
        $statusbar[0].push(1, "NOT every item in the left pane has an equivalent item in the right pane.")
		$statusbar[1].push(1, "Different bookmarks: #{differentbookmarks}")
    end

end

def foldercontcom(foldindex0, foldindex1)
	hasthesame = 0
	foldcont = 0
	foldcont2 = 0
	
	for i in (foldindex0+1)..$filelines[0]
		if $upitem0[i] == foldindex0

			for j in (foldindex1+1)..$filelines[1]
				if $upitem1[j] == foldindex1
					if $itemtxt0[i] != "-" and $itemtxt1[j] != "-" and $folder0[i] == false and $folder1[j] == false
						if $hrefatr0[i] == $hrefatr1[j] and $itemtxt0[i] == $itemtxt1[j]
							$resultstbl[i] = j
							break
						end
					end
				end
			end
		end
	end
end


def foldercomp()
	for i in (1..$filelines[0]).to_a.reverse
		if $resultstbl[i] == 0 and $itemtxt0[i] != "-" and $upitem0[i] > 0
			$resultstbl[$upitem0[i]] = 0
		end
	end
end



#===========================>	   Start	   <===========================


$mainwindow.show_all
$loadingwindow.show_all
$loadingwindow.visible=false
$aboutwindow.show_all
$aboutwindow.visible=false
$fileopenwindow.show_all
$fileopenwindow.visible=false
#filechooserdialog.visible=false
Gtk.main
